<template>
  <div class="container">
    <h1>Hello</h1>
    <form @submit.prevent="submitForm">
      <div class="form-group">
        <label for="email">Adresse Email</label>
        <input type="email" v-model="email" class="form-control" id="email" aria-describedby="emailHelp">
      </div>
      <div class="form-group">
        <label for="password">Mot de passe</label>
        <input type="password" v-model="pwd" class="form-control" id="password">
      </div>
      <div class="form-group">
        <label for="repeat-password">Répéter le mot de passe</label>
        <input type="password" v-model="repeatPwd" class="form-control" id="repeat-password">
      </div>
      <button @click="submitForm" class="btn btn-primary">S'inscrire</button>
    </form>
  </div>
</template>

<script>

import axios from 'axios'
import { db } from '@/main'
import { mapGetters } from 'vuex'

export default {
  name: 'Login',
  data: () => {
    return {
      email: '',
      pwd: '',
      repeatPwd: ''
    }
  },
  computed: {
    // map `this.user` to `this.$store.getters.user`
    ...mapGetters({
      user: 'user'
    }),
    isFormValid: function () {
      if (this.pwd !== this.repeatPwd) {
        return console.log('error')
      }
      return this.email !== '' && this.pwd !== '' && this.repeatPwd !== ''
    }
  },
  components: { },
  created () {
    // if user is auth, redirect to home page
    if (this.user.data) {
      this.$router.push('/')
    }
  },
  methods: {
    submitForm: function (e) {
      e.preventDefault()
      if (this.isFormValid) {
        db.auth()
          .createUserWithEmailAndPassword(this.email, this.pwd)
          .then((userCredential) => {
            const url = 'https://api.goneslive.fr/users'
            const body = {
              id: userCredential.user.uid,
              email: userCredential.user.email,
              date: {
                createdAt: userCredential.user.metadata.creationTime,
                updateAt: userCredential.user.metadata.lastSignInTime,
                lastSignInTime: userCredential.user.metadata.lastSignInTime
              }
            }
            axios({
              method: 'post',
              url: url,
              data: body
            }).then(r => {
              this.$router.push('/')
            }).catch(e => {
              console.log(e.response)
            })
            // ...
          })
          .catch((error) => {
            console.error(error)
            // ...
          })
      }
    }
  }
}
</script>
